#!/usr/bin/env python

import sys
import Numeric, RandomArray, LinearAlgebra
import sparse

N = 100                                  # Size of coeff matrix
n = 6                                    # Half bandwidth, more or less

A = RandomArray.random([N,N]) + Numeric.identity(N)
A_sp = sparse.sparse()

# Make A banded (brute force)
for i in range(A.shape[0]):
    for j in range(A.shape[1]):
        if abs(i - j) > n:
            A[i,j] = 0.
        else:
            A_sp.set_element(i, j, A[i,j])

b = RandomArray.random(N)
b_sp = []
for i in range(b.shape[0]):
    b_sp.append(b[i])

# Solve using Numeric
x = LinearAlgebra.solve_linear_equations(A, b)

# Solve using sparse
A_sp.factor()
x_sp = A_sp.solve(b_sp)

for i in range(len(x)):
    print '%8.4f   %8.4f   %8.4f' % (x[i], x_sp[i], x[i]-x_sp[i])
