#!/usr/bin/env python

import sys
from Matrix import SparseMatrix, SimpleMatrix
import random


N = 100                                  # Size of coeff matrix
n = 6                                    # Half bandwidth, more or less

A = SimpleMatrix(N)
A_sp = SparseMatrix(N)

# Make A banded (brute force)
for i in range(N):
    for j in range(N):
        if abs(i - j) > n:
            A[i,j] = 0.
        elif i==j:
            A[i,j] = random.random()+1
        else:
            A[i,j] = random.random()
        A_sp[i,j] = A[i,j]

b = range(N)
for i in range(N):
    b[i] = random.random()

# Solve using Numeric
x = A.solve(b)

# Solve using sparse
x_sp = A_sp.solve(b)

for i in range(len(x)):
    print '%8.4f   %8.4f   %8.4f' % (x[i], x_sp[i], x[i]-x_sp[i])
